<?php

/**
 * Adds Ajax for Clear Stats button
 */
add_action( 'wp_ajax_nopriv_wp_cta_clear_stats_action', 'wp_cta_clear_stats_action' );
add_action( 'wp_ajax_wp_cta_clear_stats_action', 'wp_cta_clear_stats_action' );
function wp_cta_clear_stats_action()
{
	global $wpdb;

	$newrules = "0";
	$post_id = mysql_real_escape_string($_POST['page_id']);

	$variations = get_post_meta($post_id, 'cta_ab_variations', true);
	if ($variations)
	{
		$variations = explode(",", $variations);
		foreach ($variations as $vid)
		{
			add_post_meta( $post_id, 'wp-cta-ab-variation-impressions-'.$vid, $newrules, true ) or update_post_meta( $post_id, 'wp-cta-ab-variation-impressions-'.$vid, $newrules );
			add_post_meta( $post_id, 'wp-cta-ab-variation-conversions-'.$vid, $newrules, true ) or update_post_meta( $post_id, 'wp-cta-ab-variation-conversions-'.$vid, $newrules );
		}
	}
	header('HTTP/1.1 200 OK');
}

/* Clear Single Stats */
add_action( 'wp_ajax_nopriv_wp_cta_clear_stats_single', 'wp_cta_clear_stats_single' );
add_action( 'wp_ajax_wp_cta_clear_stats_single', 'wp_cta_clear_stats_single' );
function wp_cta_clear_stats_single()
{
	global $wpdb;

	$newrules = "0";
	$post_id = mysql_real_escape_string($_POST['page_id']);
	$vid = $_POST['variation'];

	add_post_meta( $post_id, 'wp-cta-ab-variation-impressions-'.$vid, $newrules, true ) or update_post_meta( $post_id, 'wp-cta-ab-variation-impressions-'.$vid, $newrules );
	add_post_meta( $post_id, 'wp-cta-ab-variation-conversions-'.$vid, $newrules, true ) or update_post_meta( $post_id, 'wp-cta-ab-variation-conversions-'.$vid, $newrules );

	header('HTTP/1.1 200 OK');
}

/**
 * Adds ajax to record impressions/conversions
 */

add_action('wp_ajax_wp_cta_record_conversion', 'wp_cta_record_conversion_callback');
add_action('wp_ajax_nopriv_wp_cta_record_conversion', 'wp_cta_record_conversion_callback');

function wp_cta_record_conversion_callback() {
	global $wpdb; // this is how you get access to the database
	global $user_ID;

	$cta_id = trim($_POST['cta_id']);
	$variation_id = trim($_POST['variation_id']);

	do_action('wp_cta_record_conversion',$cta_id, $variation_id);

	print $cta_id;
	die(); // this is required to return a proper result

}

/* This Function is soon to be Legacy in favor or wp_cta_record_impressions_callback */
add_action('wp_ajax_wp_cta_record_impression', 'wp_cta_record_impression_callback');
add_action('wp_ajax_nopriv_wp_cta_record_impression', 'wp_cta_record_impression_callback');

function wp_cta_record_impression_callback() {
	global $wpdb; // this is how you get access to the database
	global $user_ID;

	$global_record_admin_actions = get_option( 'wp_cta_global_record_admin_actions', '' );

	$cta_id = trim($_POST['cta_id']);
	$variation_id = $_POST['variation_id'];

	/*
	if ( $disable_admin_tracking && current_user_can( 'manage_options' ) )
	{
		echo "admin tracking disabled";
		die();
	}
	*/


	do_action('wp_cta_record_impression' , $cta_id , $variation_id );

	print $cta_id;
	die();

}
add_action('wp_ajax_wp_cta_record_impressions', 'wp_cta_record_impressions_callback');
add_action('wp_ajax_nopriv_wp_cta_record_impressions', 'wp_cta_record_impressions_callback');

function wp_cta_record_impressions_callback() {
	global $wpdb; // this is how you get access to the database
	global $user_ID;
	echo $_POST['ctas'];
	$ctas = json_decode( stripslashes($_POST['ctas']) , true );
	
	foreach ( $ctas as $cta_id => $vid ) {
		do_action('wp_cta_record_impression' , $cta_id , $vid );
	}

	print_r($ctas);
	die();

}


/**
 * ADD AJAX FOR METABOX TEMPLATE SWITCHING
 */

add_action( 'wp_ajax_nopriv_wp_cta_get_template_meta', 'wp_cta_get_template_meta' );
add_action( 'wp_ajax_wp_cta_get_template_meta', 'wp_cta_get_template_meta' );
function wp_cta_get_template_meta()
{
	global $wpdb;
	$current_template = $_POST['selected_template'];
	$post_id = $_POST['post_id'];
	$post = get_post($post_id);

	$key['args']['key'] = $current_template;

	wp_cta_show_template_options_metabox($post,$key);
	die();
}


/**
 * Add ajax for post meta save options
 */
add_action( 'wp_ajax_nopriv_wp_wp_call_to_action_meta_save', 'wp_wp_call_to_action_meta_save' );
add_action( 'wp_ajax_wp_wp_call_to_action_meta_save', 'wp_wp_call_to_action_meta_save' );
function wp_wp_call_to_action_meta_save()
{
	global $wpdb;

	if ( !wp_verify_nonce( $_POST['nonce'], "wp-call-to-action-meta-nonce")) {
		 exit("Wrong nonce");
	}

	$new_meta_val = $_POST['new_meta_val'];
	$meta_id = $_POST['meta_id'];
	$post_id = mysql_real_escape_string($_POST['page_id']);

	if ($meta_id === "main_title")
	{
		$my_post = array();
		$my_post['ID'] = $post_id;
		$my_post['post_title'] = $new_meta_val;

		// Update the post into the database
		wp_update_post( $my_post );
	}

	if ($meta_id === "the_content")
	{
		$title_save = get_post_meta($post_id, "wp-cta-main-headline", true); // fix content from removing title
		$my_post = array();
		$my_post['ID'] = $post_id;
		$my_post['post_content'] = $new_meta_val;

		// Update the post into the database
		wp_update_post( $my_post );
		add_post_meta( $post_id, "wp-cta-main-headline", $title_save, true ) or update_post_meta( $post_id, "wp-cta-main-headline", $title_save ); // fix main headline removal
	}
	else
	{
	  add_post_meta( $post_id, $meta_id, $new_meta_val, true ) or update_post_meta( $post_id, $meta_id, $new_meta_val );
	}

	header('HTTP/1.1 200 OK');
}

